from typing import Dict, List, Optional, Union

from mfire.composite.component import SynthesisModule
from mfire.text.synthesis.reducer import SynthesisReducer
from mfire.text.synthesis.temperature import TemperatureBuilder, TemperatureReducer
from mfire.text.synthesis.weather import WeatherBuilder, WeatherReducer
from tests.composite.factories import BaseCompositeFactory, SynthesisModuleFactory


class SynthesisReducerFactory(SynthesisReducer, BaseCompositeFactory):
    parent: SynthesisModuleFactory = SynthesisModuleFactory()

    def _compute(self, **_kwargs) -> Union[Dict, List[Dict]]:
        pass


class TemperatureReducerFactory(TemperatureReducer, BaseCompositeFactory):
    parent: SynthesisModuleFactory = SynthesisModuleFactory()


class WeatherReducerFactory(WeatherReducer, BaseCompositeFactory):
    parent: SynthesisModule = SynthesisModuleFactory()
    geo_id: Optional[str] = "id_axis"


class WeatherBuilderFactory(WeatherBuilder, BaseCompositeFactory):
    parent: SynthesisModuleFactory = SynthesisModuleFactory()
    reducer_class: type = WeatherReducerFactory


class TemperatureBuilderFactory(TemperatureBuilder, BaseCompositeFactory):
    parent: SynthesisModuleFactory = SynthesisModuleFactory()
